#ifndef MSP_GLTK_GRID_H_
#define MSP_GLTK_GRID_H_

#include <msp/datafile/objectloader.h>
#include "arrangement.h"

namespace Msp {
namespace GLtk {

class Grid: public Arrangement
{
public:
	class Loader: public DataFile::ObjectLoader<Grid>
	{
	public:
		Loader(Grid &);
	private:
		void next_row();
		void skip();
	};

private:
	struct Column
	{
		Edge left;
		Edge right;
	};

	std::vector<Column> columns;
	Edge row_top;
	Edge row_bottom;
	bool first_row;
	unsigned column;

public:
	Grid(Layout &, unsigned);

	void skip();
	void next_row();

private:
	virtual void process_widget(Widget &, Side, bool);
	virtual void finish_widget(Widget &);
	virtual void finish_slot();
	void finish_row();
};

} // namespace GLtk
} // namespace Msp

#endif
