#include "stack.h"

namespace Msp {
namespace GLtk {

Stack::Stack(Layout &l):
	Arrangement(l)
{ }

void Stack::process_widget(Widget &wdg, Side side, bool aligned)
{
	if(edges[side].aligned && aligned)
		add_constraint(wdg, get_align_constraint(side), side);
	edges[side].add(wdg, aligned);
}

void Stack::finish_widget(Widget &wdg)
{
	layout.set_ghost(wdg, true);
}


Stack::Loader::Loader(Stack &s):
	DataFile::ObjectLoader<Stack>(s)
{ }

} // namespace GLtk
} // namespace Msp
